$line = 0;
$text_max = 0;
$data_max = 0;
$cur_addr = 0;
$cur_scope = 0;
$text_addr = 0;
$data_addr = 0x34;

$label{"allone"} = 48;
$label{"zero"}   = 49;
$label{"one"}    = 50;
$label{"port0"}  = 51;

$mcpu_v2 = 1;

while (<>) {
	chop;
	s/#.*$//;
	s/;.*$//;
	s/\/\/.*$//;
	s/^[ \t]+//;
	s/[ \t]+$//;

	$line ++;
	@in = split(/[ 	]+/, $_);

#	printf("%d %s\n", $#in , $in[0]);
	if ($#in < 0) {
		next;
	} elsif ($#in == 0) {
		if ($in[0] eq ".text") {
			$data_addr = $cur_addr if ($cur_scope == 1);
			$cur_scope = 0;
			$cur_addr = $text_addr;
		} elsif ($in[0] eq ".data") {
			$text_addr = $cur_addr if ($cur_scope == 0);
			$cur_scope = 1;
			$cur_addr = $data_addr;
		} elsif ($in[0] =~ /^(-*[0-9]+)$/) {
			$addr = $1;
			put_data($cur_addr, $addr);
			$cur_addr ++;
		} elsif ($in[0] =~ /^0[xX]([a-zA-Z0-9]+)$/) {
			$addr = hex($1);
			put_data($cur_addr, $addr);
			$cur_addr ++;
		# macros
		} elsif ("$in[0]" eq "CLR") {
			$inst = 0x00;
			put_data3($cur_addr, $inst, 0, "allone");
			$cur_addr ++;
		} elsif ("$in[0]" eq "NOT") {
			$inst = 0x00;
			put_data3($cur_addr, $inst, 0, "zero");
			$cur_addr ++;
		} elsif ($in[0] =~ /^([a-zA-Z_][a-zA-Z0-9_]*):$/) {
			if (exists ($label{"$1"})) {
			} else {
printf("# %s = %02X\n", "$1" , $cur_addr);
			}
			$label{"$1"} = $cur_addr;
		} elsif ($in[0] =~ /^([a-zA-Z_][a-zA-Z0-9_]*)$/) {
			if (exists ($label{"$1"})) {
				$addr = $label{"$1"};
				put_data($cur_addr, $addr);
				$cur_addr ++;
			} else {
				put_data2($cur_addr, 0, "$1");
				$cur_addr ++;
			}
		} else {
			print STDERR "$line: syntax error \n";
			printf STDERR ("\t[%s] [%s]\n", $in[0], $in[1]);
		}
	} elsif ($#in == 1) {
		my($n);
		$n = "";
		if ($in[1] =~ /^([a-zA-Z_][a-zA-Z0-9_]*)$/) {
			if (exists ($label{"$1"})) {
				$addr = $label{"$1"};
			} else {
				$addr = 0;
				$n = "$1";
			}
		} elsif ($in[1] =~ /^(-*[0-9]+)$/) {
			$addr = $1;
		} elsif ($in[1] =~ /^0[xX]([a-zA-Z0-9]+)$/) {
			$addr = hex($1);
		} else {
			print STDERR "$line: address not found\n";
		}
		if ("$in[0]" eq "NOR") {
			$inst = 0x00;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
		} elsif ($mcpu_v2 && ("$in[0]" eq "LDI")) {
			$inst = 0x20;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
		} elsif ("$in[0]" eq "ADD") {
			$inst = 0x40;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
		} elsif ("$in[0]" eq "STA") {
			$inst = 0x80;
			put_data3($cur_addr, $inst, + $addr, $n);
			$cur_addr ++;
		} elsif ("$in[0]" eq "JCC") {
			$inst = 0xC0;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
		# macros
		} elsif ("$in[0]" eq "LDA") {
			# NOR allone (CLR)
			$inst = 0x00;
			put_data3($cur_addr, $inst, 0, "allone");
			$cur_addr ++;
			# ADD mem
			$inst = 0x40;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
		} elsif ("$in[0]" eq "JMP") {
			# JCC dst
			$inst = 0xC0;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
			# JCC dst
			$inst = 0xC0;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
		} elsif ("$in[0]" eq "JCS") {
			# JCC +2
			$inst = 0xC0;
			put_data3($cur_addr, $inst, $cur_addr + 2, "");
			$cur_addr ++;
			# JCC dst
			$inst = 0xC0;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
		} elsif ("$in[0]" eq "SUB") {
			# NOR zero (NOT)
			$inst = 0x00;
			put_data3($cur_addr, $inst, 0, "zero");
			$cur_addr ++;
			# ADD mem
			$inst = 0x40;
			put_data3($cur_addr, $inst, $addr, $n);
			$cur_addr ++;
			# ADD one
			$inst = 0x40;
			put_data3($cur_addr, $inst, 0, "one");
			$cur_addr ++;
		} else {
			print STDERR "$line: unkown inst.\n";
		}
	}
	if ($cur_scope == 0) {
		$text_addr = $cur_addr;
	} else {
		$data_addr = $cur_addr;
	}
}

	for ($a = 0; $a <= $text_max ; $a++) {
		my($d, $l);
		if (exists($text_out[$a])) {
			$d = $text_out[$a];
			$l = $text_label[$a];
			if (exists($label{"$l"})) {
printf("T %02X: %02X (%s)\n", $a, $d + $label{"$l"},"$l") if ($mcpu_v2 == 0);
printf("T %02X: %03X (%s)\n", $a, $d + $label{"$l"},"$l") if ($mcpu_v2);
			} elsif ("$l" eq "") {
printf("T %02X: %02X \n", $a, $d) if ($mcpu_v2 == 0);
printf("T %02X: %03X \n", $a, $d) if ($mcpu_v2);
			} else {
printf("T %02X: %02X +%s\n", $a, $d, "$l") if ($mcpu_v2 == 0);
printf("T %02X: %03X +%s\n", $a, $d, "$l") if ($mcpu_v2);
			}
		}
	}

sub put_data {
        my($addr, $data);
        $addr = @_[0];
        $data = @_[1];
	if ($cur_scope == 0) {
		$text_max = $addr if ($text_max < $addr);
#printf("T %02X: %02X\n", $addr, $data & 0xff) if ($mcpu_v2 == 0);
#printf("T %02X: %03X\n", $addr, $data & 0xfff) if ($mcpu_v2);
		$text_out[$addr] = $data;
		$text_label[$addr] = "";
	} else {
		$data_max = $addr if ($data_max < $addr);
		$data_out[$addr] = $data;
printf("D %02X: %02X\n", $addr, $data & 0xff); 
	}
}

sub put_data2 {
        my($addr, $data, $label);
        $addr = @_[0];
        $data = @_[1];
        $label = @_[2];
	if ($label eq "") {
		put_data($addr, $data);
	} elsif ($cur_scope == 0) {
		$text_max = $addr if ($text_max < $addr);
#printf("T %02X: %02X +%s\n", $addr, $data, $label) if ($mcpu_v2 == 0);
#printf("T %02X: %03X +%s\n", $addr, $data, $label) if ($mcpu_v2);
		$text_out[$addr] = $data;
		$text_label[$addr] = "$label";
	} else {
		$data_max = $addr if ($data_max < $addr);
		$data_out[$addr] = $data;
printf("D %02X: %02X +%s\n", $addr, $data, $label); 
	}
}

sub put_data3 {
        my($addr, $inst, $data, $label);
        $addr = @_[0];
        $inst = @_[1];
        $data = @_[2];
        $label = @_[3];
	if ($mcpu_v2) {
		put_data2($addr, $inst * 16 | ($data & 0xff) , $label);
	} else {
		put_data2($addr, $inst | ($data & 0x3f) , $label);
	}
}
